import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


public class GuiSignChangeObserver implements java.util.Observer {


    public void update( java.util.Observable source, Object event ) {

	if( ! (event instanceof ChangeEvent) ) return;

	ChangeEvent ce = (ChangeEvent) event;

	if( ce instanceof IncreaseEvent ) {
	    label.setForeground( Color.RED );
	    label.setText("++++");
	} else {
	    label.setForeground( Color.BLUE );
	    label.setText("----");
	}
    }




    private JLabel label = new JLabel();


    public Component createComponents() {

        JPanel pane = new JPanel();
        pane.setBorder(BorderFactory.createEmptyBorder(
                                        30, //top
                                        30, //left
                                        30, //bottom
                                        30) //right
                                        );
        pane.setLayout(new BorderLayout());

        pane.add(label, BorderLayout.CENTER);

        return pane;
    }



    public GuiSignChangeObserver() {

	try {
	    UIManager.setLookAndFeel(
		       UIManager.getCrossPlatformLookAndFeelClassName());
	} catch (Exception e) { }



       //Create the top-level container and add contents to it.
        JFrame frame = new JFrame("Active Value Sign Change Observer");

        Component contents = createComponents();
        frame.getContentPane().add(contents, BorderLayout.CENTER);

	frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        frame.pack();
	frame.setSize( 150, 150 );



        frame.setVisible(true);
    }

}
