import java.util.List;
import java.util.ArrayList;

public abstract class Application {

    public Application() {
	documents = new ArrayList<Document>();
    }

    // the factory method!
    protected abstract Document createDocument();

    public void newDocument() {
	Document toadd = createDocument();
	documents.add( toadd );
	toadd.open();
    }

    public void saveAll() {
	for( Document d: documents ) {
	    d.save();
	}
    }

    public void closeAll() {
	for( Document d: documents ) {
	    d.close();
	}
    }
    
    private List<Document> documents;
}
